//
// PageSettingsScheduler.h
//
// Copyright (c) Shareaza Development Team, 2002-2005.
// This file is part of SHAREAZA (www.shareaza.com)
//
// Shareaza is free software; you can redistribute it
// and/or modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
//
// Shareaza is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Shareaza; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#if !defined(AFX_PAGESETTINGSSCHEDULER_H__INCLUDED_)
#define AFX_PAGESETTINGSSCHEDULER_H__INCLUDED_

#pragma once

#include "WndSettingsPage.h"


class CSchedulerSettingsPage : public CSettingsPage
{
// Construction
public:
	CSchedulerSettingsPage();
	virtual ~CSchedulerSettingsPage();

	DECLARE_DYNCREATE(CSchedulerSettingsPage)

// Dialog Data
public:
	//{{AFX_DATA(CSchedulerSettingsPage)
	enum { IDD = IDD_SETTINGS_SCHEDULER };
	BOOL	m_bSchedulerEnable;
	CSpinButtonCtrl	m_wndLimitedSpin;
	int		m_nLimited;
	BOOL	m_bLimitedNetworks;
	CStatic	m_wndDisplay;
	//}}AFX_DATA

// Painting Data
protected:
	BYTE			m_pSchedule[7][24];		// 2D Array representing the schedule

	CImageList		m_pTimeSlices;			// Images for the three states a time slice can be in
	CBitmap			m_bmHeader;				// Header graphic (times)

	BYTE			m_nHoverDay;
	BYTE			m_nHoverHour;
	BYTE			m_nDownDay;
	BYTE			m_nDownHour;

	CString			m_sDayName[7];			// List of day names

// Overrides
public:
	//{{AFX_VIRTUAL(CSchedulerSettingsPage)
	public:
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CSchedulerSettingsPage)
	virtual BOOL OnInitDialog();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_PAGESETTINGSSCHEDULER_H__INCLUDED_)
